/**
  Message.java

  Copyright (C) 1997,1998 Geometrek

 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrixIP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package matrix;

import java.io.*;

/**
 * A Message sent between the server and client.
 * It defines the protocol used and handles parsing and building
 * the messages.
 *
 * @version 1.1
 */
public abstract class Message implements Serializable, Cloneable {
  public abstract int getType();
  public abstract void write( DataOutputStream out ) throws IOException;
  public abstract void read( DataInputStream in ) throws IOException;
  
  public Message copy() {
      try {
        return (Message)clone();
      } catch(CloneNotSupportedException e){}
      return null;
  }
}
