/*
  LoginPanel.java

Copyright (C) 1998 Geometrek
 
 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrix V1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix V1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.chat;

import java.awt.*;
import matrix.deck.BorderPanel;

public class LoginPanel extends BorderPanel
{
  protected TextField Username = null;
  protected Button Connect = null;
  protected Label Status = null;
  protected Canvas Show = null;
  protected GridBagLayout inputlayout;
  protected BorderPanel inputpan;
  private Container parent;

  public LoginPanel( Container parent )
  {
    super( BorderPanel.RAISED );
    this.parent = parent;

    setOuterMargin( 0 );

    Color bg = parent.getBackground();
    setBackground( bg );
    Color fg = parent.getForeground();
    setForeground( fg );

    GridBagLayout mainLayout = new GridBagLayout();
    setLayout( mainLayout );

    inputpan = new BorderPanel( BorderPanel.ETCHED_IN );
    inputlayout = new GridBagLayout();
    inputpan.setLayout( inputlayout );

    Label lavaVar0 = new Label( "User Name", Label.LEFT );
    inputlayout.setConstraints( lavaVar0, makeGridCons( 0, 0, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    inputpan.add( lavaVar0 );
    Username = new TextField( "", 15 );
    inputlayout.setConstraints( Username, makeGridCons( 1, 0, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
    inputpan.add( Username );
    Connect = new Button( "Connect" );
    inputlayout.setConstraints( Connect, makeGridCons( 1, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
    Connect.setBackground( bg );
    Connect.setForeground( fg );
    inputpan.add( Connect );
    mainLayout.setConstraints( inputpan, makeGridCons( 2, 0, 1, 2, 0, 100, GridBagConstraints.VERTICAL, GridBagConstraints.EAST, 0, 0, 0, 0, 0, 0 ));
    add( inputpan );

    BorderPanel pan = new BorderPanel( BorderPanel.LOWERED );
    pan.setInnerMargin(2);
    pan.setLayout( new GridLayout(1,0,0,0));
    Status = new Label( "Enter a username, select an avatar and press CONNECT !", Label.CENTER );
    Status.setFont( new Font("Helvetica", Font.BOLD, 12 ));
    pan.add( Status );
    mainLayout.setConstraints( pan, makeGridCons( 0, 2, GridBagConstraints.REMAINDER, 2, 100, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    add( pan );
    pan = new BorderPanel( BorderPanel.ETCHED_IN );
    mainLayout.setConstraints( pan, makeGridCons( 0, 0, 2, 2, 100, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    add( pan );
    GridBagLayout logo = new GridBagLayout();
    pan.setLayout( logo );
    Label t = new Label("MATRIX",Label.CENTER);
    t.setFont( new Font("Helvetica", Font.BOLD, 30 ));
    logo.setConstraints( t, makeGridCons( 0, 0, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    pan.add( t );
    t = new Label("Welcome to the Matrix System !", Label.CENTER );
    logo.setConstraints( t, makeGridCons( 0, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    pan.add( t );
    t = new Label("Enter a username and press Connect");
    logo.setConstraints( t, makeGridCons( 0, 2, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    pan.add( t );

  }

  public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
  {

    GridBagConstraints cons = new GridBagConstraints();

    cons.weightx    = wx;
    cons.weighty    = wy;
    cons.gridx      = x;
    cons.gridy      = y;
    cons.gridwidth  = dx;
    cons.gridheight = dy;
    cons.fill       = fill;
    cons.anchor     = anch;
    cons.insets     = new Insets( it, il, ib, ir );
    cons.ipadx      = px;
    cons.ipady      = py;

    return cons;

  }
}
