/*
  LoginPanel.java


  Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck;

import java.awt.*;

/**
 * LoginPanel puts together the components for the client's use before connecting or after disconnecting.
 */

public class LoginPanel extends BorderPanel
{
  protected String sPassWord = "Enter a username, select an avatar and press CONNECT !";
  protected TextField Username = null;
  protected TextField Password = null;
  protected TextField Url = null;
  protected Choice Avatar = null;
  protected Button Connect = null;
  protected Label Status = null;
  protected Label T1 = null;
  protected Label T2 = null;
  protected Label T3 = null;
  protected Label lavaVar0 = null;
  protected Label lavaVar1 = null;
  protected Label lavaVar2 = null;
  protected Label [] T4 = null;
  protected Canvas Show = null;
  protected GridBagLayout inputlayout;
  protected BorderPanel inputpan, textpan, statuspan;
  private Container parent;

  public LoginPanel( Container parent, String[] lines, int iPL )
  {
    super( BorderPanel.RAISED );
    this.parent = parent;

    setOuterMargin( 0 );

    Color bg = parent.getBackground();
    setBackground( bg );
    Color fg = parent.getForeground();
    setForeground( fg );

    GridBagLayout mainLayout = new GridBagLayout();
    setLayout( mainLayout );
    textpan = new BorderPanel( BorderPanel.ETCHED_IN );
    if(1<iPL){
    mainLayout.setConstraints( textpan, makeGridCons( 0, 0, 2, 1, 100, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    }    
 else {
   mainLayout.setConstraints( textpan, makeGridCons( 0, 0, 2, 2, 100, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
    }
    add( textpan );
    GridBagLayout logo = new GridBagLayout();
    textpan.setLayout( logo );

    if( lines == null ){
      T1 = new Label("DeepMatrix Beta", Label.CENTER);
      T1.setFont( new Font("Helvetica", Font.BOLD, 30 ));
      logo.setConstraints( T1, makeGridCons( 0, 0, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
      textpan.add( T1 );
      T2 = new Label("Welcome to the DeepMatrix System !", Label.CENTER );
      logo.setConstraints( T2, makeGridCons( 0, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
      textpan.add( T2 );
      T3 = new Label("Enter a username, select an Avatar, then press Connect");
      logo.setConstraints( T3, makeGridCons( 0, 2, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
      textpan.add( T3 );
    }
    else if( lines.length > 0 ){
        T1 = new Label( lines[0], Label.CENTER);
        T1.setFont( new Font("Helvetica", Font.BOLD, 30 ));
        logo.setConstraints( T1, makeGridCons( 0, 0, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
        textpan.add( T1 );
        T4 = new Label[lines.length-1];
        for( int i = 1; i < lines.length; i++ ){
          T4[i-1] = new Label( lines[i], Label.CENTER );
          logo.setConstraints( T4[i-1], makeGridCons( 0, i, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
          textpan.add( T4[i-1] );
         }
    }
     statuspan = new BorderPanel( BorderPanel.LOWERED );
	if(1<iPL){
  sPassWord = "Enter a username,password then select an avatar and press CONNECT !";
  statuspan.setOuterMargin(0);
     }
    statuspan.setInnerMargin(1);  
    statuspan.setLayout( new GridLayout(1,0,0,0) );
    Status = new Label( sPassWord, Label.CENTER );
    Status.setFont( new Font("Helvetica", Font.BOLD, 12 ));
    statuspan.add( Status );
   System.out.println("Login iPL: " + iPL );
  if(1==iPL){
    mainLayout.setConstraints( statuspan, makeGridCons( 0, 2, GridBagConstraints.REMAINDER, 2, 100, 100, GridBagConstraints.VERTICAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
   }
  else {
  mainLayout.setConstraints( statuspan, makeGridCons( 0, 1, GridBagConstraints.RELATIVE, 2, 100, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0, 0, 0, 0, 0, 0 ) );
   }
    add( statuspan );

   inputpan = new BorderPanel( BorderPanel.ETCHED_IN );
    inputlayout = new GridBagLayout();
    inputpan.setLayout( inputlayout );
    lavaVar0 = new Label( "User Name", Label.LEFT );
    inputlayout.setConstraints( lavaVar0, makeGridCons( 0, 0, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    inputpan.add( lavaVar0 );
    lavaVar1 = new Label( "Avatar", Label.LEFT );
    //inputlayout.setConstraints( lavaVar1, makeGridCons( 0, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    //inputpan.add( lavaVar1 );
    lavaVar2 = new Label( "Avatar URL", Label.LEFT );
    //inputlayout.setConstraints( lavaVar2, makeGridCons( 0, 2, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    //inputpan.add( lavaVar2 );
    Username = new TextField( "", 15 );
    inputlayout.setConstraints( Username, makeGridCons( 1, 0, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
    inputpan.add( Username );
	Avatar = new Choice();
    Avatar.setBackground( bg );
    Avatar.setForeground( fg );
    Url = new TextField( "", 15 );
    Connect = new Button( "Connect" );
    Connect.setBackground( bg );
    Connect.setForeground( fg );
    if(1<iPL){
    Label lavaVar3 = new Label( "Password", Label.LEFT );
    inputlayout.setConstraints( lavaVar3, makeGridCons( 0, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    inputpan.add( lavaVar3 );
	Password = new TextField( "", 15 );
    inputlayout.setConstraints( Password, makeGridCons( 1, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
    inputpan.add( Password );
	inputlayout.setConstraints( lavaVar1, makeGridCons( 0, 2, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( lavaVar2, makeGridCons( 0, 3, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( Avatar, makeGridCons( 1, 2, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( Url, makeGridCons( 1, 3, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( Connect, makeGridCons( 1, 4, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
	 }
    else {
	inputlayout.setConstraints( lavaVar1, makeGridCons( 0, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( lavaVar2, makeGridCons( 0, 2, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 4, 2, 2, 0, 0 ) );
    inputlayout.setConstraints( Avatar, makeGridCons( 1, 1, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( Url, makeGridCons( 1, 2, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
	inputlayout.setConstraints( Connect, makeGridCons( 1, 3, 1, 1, 100, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 2, 2, 2, 2, 0, 0 ) );
    }
	inputpan.add( lavaVar1 );
	inputpan.add( lavaVar2 );
    inputpan.add( Avatar ); 
    inputpan.add( Url );
    inputpan.add( Connect );
    mainLayout.setConstraints( inputpan, makeGridCons( 2, 0, 1, 2, 0, 100, GridBagConstraints.VERTICAL, GridBagConstraints.EAST, 0, 0, 0, 0, 0, 0 ));
    add( inputpan );
  }

   public void  setFGColor( Color FGC ){
	 setForeground( FGC );
    if(Avatar!=null){ 
     Avatar.setForeground( FGC );
     }
    if(Connect!=null){
    Connect.setForeground( FGC );
    }
    if(Username!=null){
    Username.setForeground( FGC );
    }
   if(Password!=null){ 
   Password.setForeground( FGC );
   }
   if(Url!=null){
    Url.setForeground( FGC );
    }
   if(Status!=null){
    Status.setForeground( FGC );
	}
    inputpan.setForeground( FGC ); 
    textpan.setForeground( FGC );
    statuspan.setForeground( FGC );
     if(T1!=null){
     T1.setForeground( FGC );
      } 
	 if(T2!=null){
     T2.setForeground( FGC );
      } 
	 if(T3!=null){
     T1.setForeground( FGC );
      } 
     if(T4!=null){
     for( int i = 0; i<T4.length; i++){
     if(T4[i]!=null){ T4[i].setForeground( FGC ); }
      }
     }
     if(lavaVar0!=null){
    	lavaVar0.setForeground( FGC );
     }
     if(lavaVar1!=null){
    	lavaVar1.setForeground( FGC );
     }
	 if(lavaVar2!=null){
    	lavaVar2.setForeground( FGC );
     }
  }
  
    public void  setBGColor( Color BGC ){
	  	 setBackground( BGC );
    if(Avatar!=null){ 
     Avatar.setBackground( BGC );
     }
    if(Connect!=null){
    Connect.setBackground( BGC );
    }
    if(Username!=null){
    Username.setBackground( BGC );
    }
   if(Password!=null){ 
   Password.setBackground( BGC );
   }
   if(Url!=null){
    Url.setBackground( BGC );
    }
   if(Status!=null){
    Status.setBackground( BGC );
	}
    inputpan.setBackground( BGC ); 
    textpan.setBackground( BGC );
    statuspan.setBackground( BGC );
	if(T1!=null){
     T1.setBackground( BGC );
      } 
	 if(T2!=null){
     T2.setBackground( BGC );
      } 
	 if(T3!=null){
     T1.setBackground( BGC );
      } 
	 if(T4!=null){
     for( int i = 0; i<T4.length; i++){
     if(T4[i]!=null){ T4[i].setBackground( BGC ); }
      }
     }
     if(lavaVar0!=null){
    	lavaVar0.setBackground( BGC );
     }
     if(lavaVar1!=null){
    	lavaVar1.setBackground( BGC );
     }
	 if(lavaVar2!=null){
    	lavaVar2.setBackground( BGC );
     }
  }

  public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
  {

    GridBagConstraints cons = new GridBagConstraints();

    cons.weightx    = wx;
    cons.weighty    = wy;
    cons.gridx      = x;
    cons.gridy      = y;
    cons.gridwidth  = dx;
    cons.gridheight = dy;
    cons.fill       = fill;
    cons.anchor     = anch;
    cons.insets     = new Insets( it, il, ib, ir );
    cons.ipadx      = px;
    cons.ipady      = py;

    return cons;

  }
}
