/**
  Gate.java

  Copyright (C) 1998 Geometrek

  This source is distributed as semi-opensource software. Please see the
  LICENSE file with this distribution or contact Geometrek (www.geometrek.com)
  for details.
*/

package matrix.deck.eai;

import matrix.RealTimeMessage;
import vrml.external.*; 
import vrml.external.field.*;
import vrml.external.exception.*;

/**
 * manages a Matrix Gate
 *
 * @version 1.0
 */
public class Gate implements EventOutObserver {
    private String target;
    private EventOut callingEvent;
    private Beta deck;
    private Node gate;
	private int vn = 0;

    public Gate( Node gate, Beta d, int VIN ) throws RuntimeException {
    deck = d;
    this.gate = gate;
	vn = VIN;
    callingEvent = gate.getEventOut("isActive");  // GC workaround
    callingEvent.advise(this,new Integer(14));
    }

	public void callback(EventOut value, double time, Object data) {
    try {
        if( value == null ) {
        System.err.println("Got null value from gate");
        return;
        }
        if(!(value instanceof EventOutSFString)) {
        System.err.println("value of class "+value.getClass().getName()+" from gate");
        return;
        }
        deck.gateFired(((EventOutSFString)callingEvent).getValue());
        }
    catch(Exception e){
        System.err.println("Ex in gate "+e);
    }
    }

   public void delete(){ if(callingEvent!=null){ callingEvent.unadvise(this); callingEvent = null; }  gate = null;  }

}
