/*
  SO.java

 Copyright (C) 1998 Geometrek and 2005 in part by Russ Kinter

 *  This file is part of SET Matrix 1.
 *
 *  SET Matrix 1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  SET Matrix 1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package matrix.deck.eai;

import matrix.deck.SO;
import vrml.external.*;
import vrml.external.field.*;



/**
 * Basic object to implement SharedObject interface and hold Transform node
 *
 * @version 1.0
 */
public class SO1 extends SO  {
    private String url;
    private String name;
    private Node  transform;
	private Node [] transforms1;
    private Node [] transforms2;

    public SO1( String name, Node transform ){
	this.name = name;
	this.transform = transform;
 }
    
	public SO1( String name, Node [] transforms1 ){
	this.name = name;
	this.transforms1 = transforms1;
 }

	public SO1( String name, Node [] transforms1, Node [] transforms2 ){
	this.name = name;
	this.transforms1 = transforms1;
	this.transforms2 = transforms2;
     }

	public SO1( String name, String url, Node transform ){
	this.name = name;
    this.url = url;
	this.transform = transform;
 }
    
	public SO1( String name, String url, Node [] transforms1 ){
	this.name = name;
	this.url = url;
	this.transforms1 = transforms1;
 }

	public SO1( String name, String url, Node [] transforms1, Node [] transforms2 ){
	this.name = name;
	this.url = url;
	this.transforms1 = transforms1;
	this.transforms2 = transforms2;
     }

    public Node getTransform(){
	return transform;
    }

	public Node [] getTransforms1(){
	return transforms1;
    }

	public Node [] getTransforms2(){
	return transforms2;
    }
    /**
     * nullifys transform node
     */
    public void delete(){
	transform = null; transforms1 = transforms2 = null;
    }   
    /**
     * sets the name of the SharedObject
     */
    public void setName( String name ){
	this.name = name;
    }

    public void setUrl( String url ){
    this.url = url;
    }

    /**
     * returns the name of the SharedObject
     */
    public String getName(){
	return name;
    }	

    public String getUrl(){
	return url;
    }	
}
