/**
  CtrlTime.java

 Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck.eai2;

import matrix.vrml.*;
import matrix.deck.RealTimeConsumer;
import matrix.deck.ConsumerException;
import matrix.deck.CtrlEvent;
import matrix.deck.Network;
import java.io.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

/**
 * manages a single VRML route. Now this is a Living Worlds' NetworkState node.
 *
 * @version 1.1
 */
public class CtrlTime  implements CtrlEvent, VrmlEventListener {
    private String name;
    private String username = "";
    private String sLock = "#open";
    private Node myNode = null;
    private EventOutSFTime time_out = null;
	private EventInSFString setLock = null;
	private EventInSFString setName = null;
    private EventIn fromnet;
    private Network postOffice;

 public CtrlTime( Node netnode, Network office, String un ) {
	postOffice = office;
	myNode = netnode;
    username = un;
    try {
	this.name = ((EventOutSFString)myNode.getEventOut("tag")).getValue();
    setLock = ((EventInSFString)myNode.getEventIn("set_lock"));
	setName = ((EventInSFString)myNode.getEventIn("set_name"));
	time_out = (EventOutSFTime)myNode.getEventOut("control_time");
    time_out.addVrmlEventListener(this);
    setName.setValue(username);
     }
	catch(NullPointerException f){ System.out.println( "CtrlTime error: " + f ); }
    catch(InvalidEventInException g){System.out.println( "CtrlTime error: " + g );  }
    catch(InvalidEventOutException h){System.out.println( "CtrlTime error: " + h ); } 
    catch(Error j){ System.out.println( "CtrlTime error: " + j );  }
    }

	public void eventOutChanged( VrmlEvent vrmlevent ) {
    BaseField bf =  vrmlevent.getSource();
		if( bf.getType()==BaseField.SFTime ) {
     // System.out.println("CtrlTime: got time");
      try {
     setName.setValue(username);
	 if(sLock.equals("#open")){
     System.out.println("CtrlTime sLock is open " );
     postOffice.sendControlEvent( name, new String [] { username, "#lock"} );
     }
     else 
	 if(sLock.equals(username)&&!username.equals("")){
	 System.out.println("CtrlTime sLock was controlled now opening " );
     postOffice.sendControlEvent( name, new String [] { username,"#open"} );
       }
     } 
	 catch(InterruptedException f){System.err.println("CtrlTime: " + f);} 
     catch(IOException e){System.err.println("CtrlTime: " + e); }
      }
	 else
    return;
    }
   

    public void handleLock( String [] lock ){
	    if(lock[0]!=null){ sLock = lock[0];
    if(setLock!=null){ setLock.setValue( sLock ); }
     }
    }

	   public void setCtrlName( String name ){
	this.name = name;
    }

   	 public String ctrlName(){
    return name;
    }

	public void ctrlDelete(){                              
if(time_out!=null){ time_out.removeVrmlEventListener(this);	
 time_out = null;
    }
}

}
