/*
  EAIViewer.java

  Copyright (C) 1998 Geometrek

  This source is distributed as semi-opensource software. Please see the
  LICENSE file with this distribution or contact Geometrek (www.geometrek.com)
  for details.
*/

package matrix.deck.eai_applet;

import java.io.IOException;
import matrix.deck.eai.*;
import matrix.deck.*;
import java.applet.*;
import java.util.*;
import java.net.UnknownHostException;
import java.net.InetAddress;
import vrml.external.*;
import vrml.external.field.*;
import vrml.external.exception.*;

/**
 * Viewer for EAI VRML browser connection. Does the basic EAI stuff such as
 * loading and removing of objects and worlds.
 *
 * @version 1.0
 */
public class EAIViewer implements Viewer, Runnable {

    
   /**
    * New 11-12-05 viewernum is for which VRML plugin is being used.
    */
    private int viewernum = 0;
    /**
    * New 11-12-05 counter for heart beat every seven seconds.
    */
    private boolean bRootWRL = false;
    public static boolean bCloseState = false;
	private int iBrowserCt = 0;
    private int cnt = 0;
    private Browser browser;
    private boolean bTransit = false;
    private int iTransit = 3;
    private boolean bDisconnect = false;
    /**
    * New 11-12-05 updateOk is to determine if VRML plugin has begin and end update methods from later EAI
    */
    public boolean updateOk = false;
    /**
    * New 11-12-05 bNet status is determined in run to indicate if Network is connected to send heart beat. 
    */
    public boolean bNet = false;
	private Node switchNode = null;
    private EventInSFInt32 hide = null;
    /**
    * EAI stuff
    * New 11-12-05 scrpNode holds a new Script Node found in the root world named "SCRP"
    * This script appears to do nothing, but in fact is very important because it enables
    * the heart beat thread to get caught up with the VRML browser by making the EventInSFBool 
    * "addBool" true. See below    
    */
    private Node scrpNode = null;
    /**
    * EAI stuff
    * New 11-12-05 addBool is gotten from scrpNode Script Node ( see above ) It is set true
    * just before a heart beat is sent over network. 
    */
    private EventInSFBool addBool = null;
   /**
    * EAI stuff
    * rooNode is the main Grouping Node to which contains all the added worlds, avatars and objects.
    * The three EventInMFNode and one EventOutMFNode below it control the VRML comings and goings. 
    */
    private Node [] rootNode = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * All VRML from the createVRMLfromURL call except the Room name VRML is added here at the run method.
    * 
    */
    private EventInMFNode addChildren = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * All VRML from the createVRMLfromURL call except the Room name VRML is removed here at the reset method.
    * 
    */
    private EventInMFNode removeChildren = null;
    /**
    * EAI stuff
    * Belongs to rootNode.
    * The Room name VRML is added here at the run method. 
    */
    private EventInMFNode setChildren = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * Used in reset method to get list of VRML Nodes actually added to the room, so they can be removed.
    */
    private EventOutMFNode childrenChanged = null;

    private Node [] poolNode = null;
   
    private EventInMFNode add_P_Children = null;
   
    private EventInMFNode remove_P_Children = null;
    
    private EventInMFNode set_P_Children = null;
   
    private EventOutMFNode children_P_Changed = null;
    
	private String sVendor;
    private String sOSname;
    private String sOSarch;
    private String sOSversion;
	private static String sShutdown;


    /**
     * Viewer interface stuff
     */
    private Vector listeners = new Vector();
    // other things
    private String worldName;

    private String userName;

    private Thread runner;

       /**
     * Indicates LoadObserver instance is finished and not to repeat.
     */

 private boolean loadFlag = false;

	/**
     * VRML object loaded successfully if true.
     */

  private boolean bSuccess = true;

  /**
   *   SO in loaded -- run()        --> places SO in "objects" Hashtable below.
   */

    Vector loaded = new Vector(1);

   /**
    * SO in objects -- removeObject --> removes SO from world & objects
    */

     Hashtable objects = new Hashtable();



 
 /**
   * New 3-11-08 Constructor for standalone InstantPlayer -reworked FreeWRL code. 
  */
 
    public EAIViewer() {
       nullifyRootVRML();        
	}

	 public EAIViewer( Applet applet, String frame, String sV, String sOS, String sArch, String sVersion, String sShutdown ) {
   sVendor = sV; sOSname = sOS; sOSarch = sArch; sOSversion = sVersion; this.sShutdown = sShutdown; 
     try { 
      createBrowser( applet, frame ); 
       }
      catch(Exception e){}    
	}

    public Browser getBrowser(  ){
	return browser;
    }
  

  private void getRoot(){
Node Foo = null;
     try { 
     switchNode = browser.getNode("SW");
     }
  catch(NullPointerException g){ System.out.println( "Root Node failure: " + g);
  return;}
  catch(InvalidNodeException d){ System.out.println( "Root Node failure: " + d);
  return;} 
  catch(InvalidVrmlException f){ System.out.println( "Root Node failure: " + f);
  return;} 

     try {
     hide = (EventInSFInt32)switchNode.getEventIn("whichChoice");
     rootNode = ((EventOutMFNode)switchNode.getEventOut("choice")).getValue();
	 addChildren = (EventInMFNode)rootNode[0].getEventIn("addChildren");
	    removeChildren = (EventInMFNode)rootNode[0].getEventIn("removeChildren");
	    setChildren = (EventInMFNode)rootNode[0].getEventIn("set_children");
	    childrenChanged = (EventOutMFNode)rootNode[0].getEventOut("children_changed");
     Foo = browser.getNode("SW2");
	 poolNode = ((EventOutMFNode)Foo.getEventOut("choice")).getValue();
	 add_P_Children = (EventInMFNode)poolNode[0].getEventIn("addChildren");
	    remove_P_Children = (EventInMFNode)poolNode[0].getEventIn("removeChildren");
	    set_P_Children = (EventInMFNode)poolNode[0].getEventIn("set_children");
	    children_P_Changed = (EventOutMFNode)poolNode[0].getEventOut("children_changed");
      }
  catch(NullPointerException g){ System.out.println( "Root Node failure: " + g);
  return;}
  catch(InvalidNodeException d){ System.out.println( "Root Node failure: " + d);
  return;} 
  catch(InvalidVrmlException f){ System.out.println( "Root Node failure: " + f);
  return;} 
  catch (InvalidEventInException ei) {
     System.out.println( "Root EventIn exception: "+ ei);
    return;
      }
     catch (InvalidEventOutException ou) {
     System.out.println( "Root EventOut exception: "+ ou);
    return;
      }
  catch(Exception e){ System.out.println( "Root Node failure: " + e);
  return;}
       try {
       scrpNode = browser.getNode("SCRP");
        }
    catch(InvalidNodeException d){ System.out.println( "Script Node failure: " + d);
    return;} 
    catch(InvalidVrmlException f){ System.out.println( "Script Node failure: " + f);
    return;} 
    catch(NullPointerException g){ System.out.println( "Script Node failure: " + g);
    return;} 
      catch(Exception e){ System.out.println( "Script Node failure: " + e ); 
    return;}
         try {
       addBool = (EventInSFBool)scrpNode.getEventIn("heartBeat");
          }
  	  catch(NullPointerException g){
         System.out.println( "SCRP NullPointerException EventIn: "+ g);
         return;
          }
          catch (InvalidEventInException ei2) {
       System.out.println( "SCRP -heartBeat: "+ ei2);
          return;
          }
      }

 /**
  * New 11-12-05 Originally called in the Beta applet's start method.
  * Moved to handleRoom_A and only called at the very first room.
  */

  void start(){
    if(runner==null){
	runner = new Thread( this,"Viewer_Heart" );
	runner.start();
     }
    }

  /**
    * Called at Beta applet stop. 
    */ 

    public void stop(){
	runner = null;
    }

 // &&viewernum!=2

   private void createBrowser( Applet applet, String frame ){
 	browser = null;
	while(browser == null) {
 if(!frame.equals("default")){
	    try {
		browser = Browser.getBrowser(applet,frame,0); // 
	    }
	    catch(NullPointerException e){
		System.err.println("No browser pointer "+e);
	    }
   }
  else { 
   try {
		browser = Browser.getBrowser(applet); // 
	    }
	    catch(NullPointerException e){
		System.err.println("No browser pointer "+e);
	    }
   }
	}
	if( browser == null ) {
	    System.out.println("EAIViewer : Didn't get browser pointer");
      return;
	}

	try {
	    // check for begin/endUpdate capability
	    // this is only available on Blaxxun Contact or Parallelgraphics Cortona
	   String name = browser.getName().toLowerCase();
     if( name.indexOf("blaxxun") >= 0 || name.indexOf("contact") >= 0 ){ updateOk = true; viewernum = 0;}
     if( name.indexOf("cortona") >= 0 ){updateOk = true; viewernum = 1; }
     if( name.indexOf("freewrl") >= 0 ){updateOk = true; viewernum = 2; System.out.println("updateOk: "+ updateOk );}
	    if (name.indexOf("nexternetplayer")>= 0 || name.indexOf("cosmoplayer")>= 0 ){ viewernum = 3;}
     if (name.indexOf("worldview")>= 0){viewernum = 4; }
     } 
  	catch(Exception e){
	    System.out.println("EAIViewer : "+e);
	}
       start();
          }

 public void run(){
 SO object;
	while( Thread.currentThread() == runner  ){  
if(bTransit){
  if(iTransit==0){
      networkConsumers( true );
      reset();
      if(bDisconnect){ 
		networkConsumers( false );
		   setiTransit( 3 );
           setbTransit( false );
          }
      else {
		   setiTransit( 1 );
       }           
   }
  else 
 if(iTransit==1){
  //nullifyRootVRML();
  reloadRoot( "root.wrl" );
   System.gc();
   System.runFinalization();
   setiTransit( 2 );
   }
  else 
 if(iTransit==2){
  getRoot();
  browserAchieved( true );
	  setiTransit( 3 );
	  setbTransit( false );
   }
}
else {  
if( !loaded.isEmpty() ){ 
	  	object = (SO)loaded.elementAt(0);	   
     if( object.getName().equals( worldName )){
		 setSwitch(0);
  System.out.println("setSwitch 0 worldName: " + worldName);
		 Node [] foo = new Node [] { object.getTransform() };
  System.out.println("foo children_changed size: " + ((EventOutMFNode)foo[0].getEventOut("children_changed")).getSize() );
	 if(0<((EventOutMFNode)foo[0].getEventOut("children_changed")).getSize()){
			  objects.put( object.getName(), object );
			onWorldLoaded( object.getName(), object );
			worldName = null;
		    } 
           }
         else {
          Node [] foo2 = object.getTransforms1(); 
		   if(0<((EventOutMFNode)foo2[0].getEventOut("children_changed")).getSize()){
          Node [] foo3 = object.getTransforms2();
		  addChildren.setValue(foo3);
          ((EventInMFNode)foo3[0].getEventIn("addChildren")).setValue(foo2);
          remove_P_Children.setValue(foo2);
			  objects.put( object.getName(), object );
			onObjectLoaded( object.getName(), object );
			 }
		    } 
 		  } 
  if(bNet==true){ 
   setHeartBeatCount();
   }
}
  try{
		runner.sleep( 1000 );
	    }
	    catch( InterruptedException e ){}
    }
}

 public synchronized void setiTransit( int num ){
 iTransit = num;
 }

 public synchronized void setbTransit( boolean tf ){
 bTransit = tf;
 }

 /**
  * New 11-12-05 setHeartBeatCount sends the heart beat every seven seconds over the network by watching the global variable integer "cnt" (a counter).
  * There maybe a better way to do this.
  */
 void setHeartBeatCount(){
 if(7<=cnt){
 if(addBool!=null){ addBool.setValue(true); }
  onHeartBeat();
  cnt = 0;
  }
 else {
  cnt += 1;
  }
 }

 private synchronized void setSwitch( int choose ){
 if(hide!=null){ hide.setValue(choose);}
  else { System.out.println("whichChoice of SW is NULL!"); }
 }

 public void setUserName( String nm ){
 userName = nm;
 }


 public void resetLoaded(){ 
 loaded.removeAllElements();
 }

 public void resetAvLoaded( SO obj ){ 
 System.out.println("resetAvLoaded1 loaded size: " + loaded.size() );
 if(loaded.contains(obj)){
 loaded.removeElement(obj);
System.out.println("resetAvLoaded2 loaded contains obj size: " + loaded.size() );
}
else {
System.out.println("resetAvLoaded3 loaded does not contain obj size: " + loaded.size() );
}
 }

  /**
     * New 11-12-05 "goodbye" node created in the constructor is added 
     * to stop a NullPointerException in WorldView for those that care.
     * reset call created to differentiate it from the delete call which
     * nullifies the Browser and all VRML when the window finally closes.
     */

    public void reset(){
	setSwitch(-1);
    loaded.removeAllElements();
	objects.clear();
if( 0<childrenChanged.getSize() ){   removeChildren.setValue( childrenChanged.getValue()); }
if( 0<children_P_Changed.getSize() ){   remove_P_Children.setValue( children_P_Changed.getValue() ); }
     }

    public void viewerDisconnect( int ct ){ 
   if(ct==0){ 
      bDisconnect = true;
     setiTransit( 0 );
     setbTransit( true );
    } 
   else  
   if(ct==1){
     bDisconnect = false;
     setiTransit( 0 );
     setbTransit( true ); 
	 }
   else    
   if(ct==2){
	 bDisconnect = false;
     setiTransit( 1 );
     setbTransit( true ); 
     }
    }

 private void nullifyRootVRML(){
   add_P_Children = null;
   remove_P_Children = null;
   set_P_Children = null;
   children_P_Changed = null;
   addChildren = null;
   removeChildren = null;
   setChildren = null;
   childrenChanged = null;
   addBool = null;
   rootNode = null;
   poolNode = null;
   scrpNode = null;
   } 
 
 private void closeBrowser(){
   if(browser!=null){ 
//          browser.removeBrowserListener( new BrowserListener() {

//                public void browserChanged(BrowserEvent evt)
//                {
//                    onBrowserChanged(evt);
//                }

//            }); 
      browser.shutdown(); 
	   browser = null;
      }
 }
 
 

  private void reloadRoot( String st ){
  String [] MFfoo = {st};
  String [] MFfoo2 = {""}; 
  if(browser!=null){
    try {
    browser.loadURL(MFfoo,MFfoo2);
     }
   catch( Exception e){ System.out.println( "Root failed to load! "); }
     } 
else { System.out.println( "browser is null");}
       }
 
    // Viewer Interface start -------------------------------------------------------


   /**
     * New 11-12-05 putSO method is a callback from the Beta applet load a VRML file
     * into the objects hashtable. Previously a VRML file was loaded directly in EAIViewer
     * in the run method. This addition is to needed to find out if the VRML file previously
     * exists or not! See "onObjectLoaded" and "onWorldLoaded" methods in Beta class.   
     */


    /**
     * loads the world as background. Will also return a SharedObject
     * but might need some more initialization.  
     */

    public void loadWorld( String name, String url ){
	worldName = name;
	addSharedObject( name, url );
    }

 public void addUserAvatar( String name, String url ){
String stg = "";
Node[] help2 = null;
Node[] help = null;
if( name.equals( userName )){
System.out.println("EAIViewer addUserAvatar username 1");
                           stg = ("PROTO Avatar2 [ " +
						   "exposedField SFVec3f translation 0 0 0 "+
						   "exposedField SFRotation rotation 0 1 0 0 "+
                           "eventIn MFNode addChildren " +
						   "eventIn MFNode removeChildren " +
						   "exposedField MFNode children_changed [] " +
                           "eventIn MFNode name_tag " +
						   "exposedField SFInt32 which 0 " + 
                           " ] " +
						   "{ " +
                           "Group { "+
                           "children [ "+
                           "Switch { whichChoice IS which "+
						   "choice [ " +
                           "Group { " +
                           "children [ " +
						   "Transform { " +
                           "translation IS translation " +
						   "rotation IS rotation " +    
						   "children [ " +
						   "Transform { " +
						   "rotation 0 1 0 3.141 " +
						   "removeChildren IS removeChildren " +
						   "addChildren IS addChildren " +
						   "children IS children_changed " +
						   "}, " +
                           "Group { " +
                            "addChildren IS name_tag " +
						   " } " +
                           "]} " +
                            "]}]}]}" + 
                           " } " +
                           "Avatar2 {} " +
    					   "Viewpoint {} ");
                            }
    else { 
System.out.println("EAIViewer addUserAvatar Drone url: " + url);
         stg = ("PROTO Avatar3 [  " +
			 "exposedField SFVec3f translation 0 0 0  " +
			 "exposedField SFRotation rotation 0 1 0 0 " +
             "exposedField SFInt32 whichChoice 0 " +
			 "exposedField MFFloat range [40, 80] " +   
             "eventIn MFNode addChildren " +
    		 "eventIn MFNode addTXTChildren " +
             "eventIn MFNode removeChildren " +
			 "exposedField MFNode children_changed [] " +   
             "] " +
			 "{ " +  
			 "Group { " +
             "children [ " +
             "Switch { " +
             "whichChoice IS whichChoice " +
             "choice [ " +
             "Group { " + 
			 "children [ " + 
             "Transform { " + 
             "translation IS translation " +  
             "rotation IS rotation " +  
             "children [ " +     
             "Group { " +
             "addChildren IS addTXTChildren " +
             " } " +
             "Group { " +   
             "children [ " + 
             " LOD { " + 
             "range IS range " +   
             " level [ " +   
             "Transform { " +
			 "rotation 0 1 0 3.141 " +
             "addChildren IS addChildren " +
             "removeChildren IS removeChildren " +
			 "children IS children_changed " +  
             "  }  " +   
             "Transform {  " +  
             "translation 	0 0 0 " + 
             "children [	Shape {  " +
             "appearance	NULL  " + 
             "geometry	 IndexedFaceSet {  " + 
             "coord	Coordinate {  " + 
	            " point	[ -0.25 1.75 0.125, "  +
		  " -0.25 0.0 0.125,"  +
		  " 0.25 1.75 0.125, "  +
		  " 0.25 0.0 0.125, "  +
		  " 0.25 1.75 -0.125, "  +
		  " 0.25 0.0 -0.125, "  +
		  " -0.25 1.75 -0.125, "  +
		  " -0.25 0.0 -0.125 ] "  +
     "  } "  +
     " coordIndex	[ 0, 1, 3, 2, -1, 4, 5, 7, "  +
	       "  6, -1, 6, 7, 1, 0, -1, 2, "  +
	       "  3, 5, 4, -1, 6, 0, 2, 4, "  +
	       "  -1, 1, 7, 5, 3, -1 ] "  +
             "color Color { color [ .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3,  .3 .3 .3 ]}  " +  
             "}}]}  " + 
             "Group { } " + 
             "     ]} " + 
             "   ]} " +
             "  ]} " +
    		 " ]} " +
             "]} " +
			 "]} " +
			 "} " +
			 "Avatar3 {} "); }
 try {
help = browser.createVrmlFromString( stg );	 
      }
catch (InvalidVrmlException g) { System.out.println(" Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println(" Node prob: " + d );  
  return; }
catch(NullPointerException f){System.out.println("Null prob: " + f );
  return; }

try {
help2 = browser.createVrmlFromString( "Group {}" );	 
 }
catch (InvalidVrmlException g) { System.out.println(" Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println(" Node prob: " + d );  
  return; }
catch(NullPointerException f){System.out.println("Null prob: " + f );
  return; }
    SO object = new SO( name, url, help2, help );
    loaded.insertElementAt( object, 0 );
	 add_P_Children.setValue( help2 );
   try {
	browser.createVrmlFromURL( new String[] { url }, help2[0], "addChildren");
     }
  catch(InvalidVrmlException g){ loaded.removeElement( object );  System.out.println( "cVFU failed: " + g );return;}
  catch(NullPointerException j){ loaded.removeElement( object ); System.out.println( "cVFU failed: " + j );return;}
  catch(Exception l){loaded.removeElement( object ); System.out.println( "cVFU failed: " + l ); return; }
  } 

    /**
     * loads a SharedObject into the simulation. Identified by a name.
     * New 11-12-05 This adds a work around for WorldView VRML plugin
     * The grouping Node [] help has to be added to the Root node BEFORE  
     * the observer can tell if it succeeds. See run method above for the anti-thesis.
     *  
     */

    public void addSharedObject( String name, String url ){
Node[] help = null;
 try {
help = browser.createVrmlFromString( "Group {}" );	 
}
catch (InvalidVrmlException g) { System.out.println(" Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println(" Node prob: " + d );  
  return; }
catch(NullPointerException f){System.out.println("Null prob: " + f );
  return; }
	SO object = new SO( name, help[0] );
    loaded.insertElementAt( object, 0 );
	addChildren.setValue( help  );
  try {
	browser.createVrmlFromURL( new String[] { url }, help[0], "addChildren");
 }
  catch(InvalidVrmlException g){ loaded.removeElement( object );  System.out.println( "cVFU failed: " + g );return;}
  catch(NullPointerException j){ loaded.removeElement( object ); System.out.println( "cVFU failed: " + j );return;}
  catch(Exception l){loaded.removeElement( object ); System.out.println( "cVFU failed: " + l ); return; }
  } 



    /**
     * removes the SharedObject identified by name.
     */
    public void removeSharedObject( String name ){
	SO object = (SO) objects.remove( name );
	if( object != null ){
    if(name.equals("world")){
	    removeChildren.setValue( new Node[] { object.getTransform() } );
     }
     else {
		removeChildren.setValue(  object.getTransforms2()  );
        System.out.println("EAIViewer removeSharedObject: " + name );
     }
	}
    }
    // adding / removing ViewerListener

    /**
     * adds a ViewerListener for callbacks on successful loading.
     */
    public void addViewerListener( ViewerListener listener ){
	if( ! listeners.contains( listener ))
	    listeners.addElement( listener );
    }

    /**
     * removes a ViewerListener
     */

    public void removeViewerListener( ViewerListener listener ){
	listeners.removeElement( listener );
    }

   /**
     * New 11-12-05 beginUpdate method has been modified
     * so that which browser is ascertained before the method is actually
     * called.
     * This was necessary so Cosmoplayer would not throw nullpointer exception 
     * in I.E. 
     * See RealTimeHandler for use.
     */

    public void beginUpdate(){
	    browser.beginUpdate();
    }

    /**
     * New 11-12-05 endUpdate method has been modified
     * so that which browser is ascertained before the method is actually
     * called
     * This was necessary so Cosmoplayer would not throw nullpointer exception 
     * in I.E. 
     * See RealTimeHandler for use.
     */

    public void endUpdate(){
	    browser.endUpdate();
    }

   // Viewer Interface end ---------------------------------------------------------

   /**
     * New 11-12-05 getViewernum method VRML plugin indentification by integer.
     */

 public int getViewernum(){
 return(viewernum);}


    // helper functions for  calling listeners
    /**
     * New 11-12-05 Sets boolean bNet.
     */

  public void setbNet( boolean tf ){
  bNet = tf;
  }


    // helper functions for  calling listeners
   private void networkConsumers( boolean tf ){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).networkConsumers( tf );
     } 
  } 
    
   private void browserAchieved( boolean tf ){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).browserAchieved(tf);
     } 
   }

    /**
     * New 11-12-05 Sends hear beat to Beta to poll server
     */

   private void onHeartBeat(){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).onHeartBeat();
     } 
  } 
  
    private void onWorldLoaded( String name, SharedObject object ){
	Enumeration list = listeners.elements();
	while( list.hasMoreElements()){
	    ((ViewerListener)list.nextElement()).onWorldLoaded( name, object );
	}
    }

    private void onObjectLoaded( String name, SharedObject object ){
	Enumeration list = listeners.elements();
	while( list.hasMoreElements()){
	    ((ViewerListener)list.nextElement()).onObjectLoaded( name, object );
	}
    }

    /**
     * New 11-12-05 cleans up VRML browser and VRML.
     * This method is NOT called at all in this version.
     * The gurus in the EAI faq: http://www.frontiernet.net/~imaging/eaifaq.html#21.2
     * claim nullifying everything helps to stop crashes. However this method seems
     * to cause Cosmoplayer to crash and the other VRML browsers don't seem to crash
     * without it. It wasn't in the original version of Deep Matrix and Gerhard, the
     * original programmer certainly would have known about this supposed trick.
     * Requires more investigation and testing a "to do".
     */



public void delete(){
    runner = null;
  reset();
  closeBrowser();
  }
}
